# coding: utf-8

"""
    FINBOURNE Drive API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic.v1 import validate_arguments, ValidationError
from typing import overload, Optional, Union, Awaitable

from typing_extensions import Annotated
from pydantic.v1 import Field, StrictInt, StrictStr, conlist, constr, validator

from typing import Optional

from lusid_drive.models.paged_resource_list_of_storage_object import PagedResourceListOfStorageObject
from lusid_drive.models.search_body import SearchBody

from lusid_drive.api_client import ApiClient
from lusid_drive.api_response import ApiResponse
from lusid_drive.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)
from lusid_drive.extensions.configuration_options import ConfigurationOptions


class SearchApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @overload
    async def search(self, search_body : Annotated[SearchBody, Field(..., description="Search parameters")], page : Optional[constr(strict=True, max_length=500, min_length=1)] = None, sort_by : Optional[conlist(StrictStr)] = None, limit : Optional[StrictInt] = None, filter : Optional[constr(strict=True, max_length=16384, min_length=0)] = None, **kwargs) -> PagedResourceListOfStorageObject:  # noqa: E501
        ...

    @overload
    def search(self, search_body : Annotated[SearchBody, Field(..., description="Search parameters")], page : Optional[constr(strict=True, max_length=500, min_length=1)] = None, sort_by : Optional[conlist(StrictStr)] = None, limit : Optional[StrictInt] = None, filter : Optional[constr(strict=True, max_length=16384, min_length=0)] = None, async_req: Optional[bool]=True, **kwargs) -> PagedResourceListOfStorageObject:  # noqa: E501
        ...

    @validate_arguments
    def search(self, search_body : Annotated[SearchBody, Field(..., description="Search parameters")], page : Optional[constr(strict=True, max_length=500, min_length=1)] = None, sort_by : Optional[conlist(StrictStr)] = None, limit : Optional[StrictInt] = None, filter : Optional[constr(strict=True, max_length=16384, min_length=0)] = None, async_req: Optional[bool]=None, **kwargs) -> Union[PagedResourceListOfStorageObject, Awaitable[PagedResourceListOfStorageObject]]:  # noqa: E501
        """[EARLY ACCESS] Search: Search for a file or folder with a given name and path  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search(search_body, page, sort_by, limit, filter, async_req=True)
        >>> result = thread.get()

        :param search_body: Search parameters (required)
        :type search_body: SearchBody
        :param page: 
        :type page: str
        :param sort_by: 
        :type sort_by: List[str]
        :param limit: 
        :type limit: int
        :param filter: 
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PagedResourceListOfStorageObject
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the search_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.search_with_http_info(search_body, page, sort_by, limit, filter, **kwargs)  # noqa: E501

    @validate_arguments
    def search_with_http_info(self, search_body : Annotated[SearchBody, Field(..., description="Search parameters")], page : Optional[constr(strict=True, max_length=500, min_length=1)] = None, sort_by : Optional[conlist(StrictStr)] = None, limit : Optional[StrictInt] = None, filter : Optional[constr(strict=True, max_length=16384, min_length=0)] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] Search: Search for a file or folder with a given name and path  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_with_http_info(search_body, page, sort_by, limit, filter, async_req=True)
        >>> result = thread.get()

        :param search_body: Search parameters (required)
        :type search_body: SearchBody
        :param page: 
        :type page: str
        :param sort_by: 
        :type sort_by: List[str]
        :param limit: 
        :type limit: int
        :param filter: 
        :type filter: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: Timeout setting. Do not use - use the opts parameter instead
        :param opts: Configuration options for this request
        :type opts: ConfigurationOptions, optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PagedResourceListOfStorageObject, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'search_body',
            'page',
            'sort_by',
            'limit',
            'filter'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers',
                'opts'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('page') is not None:  # noqa: E501
            _query_params.append(('page', _params['page']))

        if _params.get('sort_by') is not None:  # noqa: E501
            _query_params.append(('sortBy', _params['sort_by']))
            _collection_formats['sortBy'] = 'multi'

        if _params.get('limit') is not None:  # noqa: E501
            _query_params.append(('limit', _params['limit']))

        if _params.get('filter') is not None:  # noqa: E501
            _query_params.append(('filter', _params['filter']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['search_body'] is not None:
            _body_params = _params['search_body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "PagedResourceListOfStorageObject",
            '400': "LusidValidationProblemDetails",
        }

        return self.api_client.call_api(
            '/api/search', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            opts=_params.get('opts'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
