# coding: utf-8

"""
    FINBOURNE Drive API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic.v1 import BaseModel, Field, constr, validator

class SearchBody(BaseModel):
    """
    DTO representing the search query  # noqa: E501
    """
    with_path: Optional[constr(strict=True, max_length=512, min_length=1)] = Field(None, alias="withPath", description="Optional path field to limit the search to result with a matching (case insensitive) path")
    name: constr(strict=True, max_length=256, min_length=1) = Field(..., description="Name of the file or folder to be searched")
    __properties = ["withPath", "name"]

    @validator('with_path')
    def with_path_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[\/a-zA-Z0-9 \-_]+$", value):
            raise ValueError(r"must validate the regular expression /^[\/a-zA-Z0-9 \-_]+$/")
        return value

    @validator('name')
    def name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[A-Za-z0-9_\-\.]+[A-Za-z0-9_\-\. ]*$", value):
            raise ValueError(r"must validate the regular expression /^[A-Za-z0-9_\-\.]+[A-Za-z0-9_\-\. ]*$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SearchBody:
        """Create an instance of SearchBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if with_path (nullable) is None
        # and __fields_set__ contains the field
        if self.with_path is None and "with_path" in self.__fields_set__:
            _dict['withPath'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SearchBody:
        """Create an instance of SearchBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SearchBody.parse_obj(obj)

        _obj = SearchBody.parse_obj({
            "with_path": obj.get("withPath"),
            "name": obj.get("name")
        })
        return _obj
